diff -urpN ksmbd-tools-3.1.0/lib/management/session.c ksmbd-tools-3.1.0.new/lib/management/session.c
--- ksmbd-tools-3.1.0/lib/management/session.c	2020-01-22 18:12:55.000000000 +0400
+++ ksmbd-tools-3.1.0.new/lib/management/session.c	2020-01-26 13:58:13.868726106 +0400
@@ -7,18 +7,17 @@
 
 #include <stdlib.h>
 #include <string.h>
-#include <glib.h>
 #include <linux/usmbd_server.h>
-
+#include <pthread.h>
 #include <management/session.h>
 #include <management/tree_conn.h>
 #include <management/user.h>
 #include <usmbdtools.h>
 
-static GHashTable	*sessions_table;
-static GRWLock		sessions_table_lock;
+static struct LIST *sessions_table;
+static pthread_rwlock_t sessions_table_lock;
 
-static void __free_func(gpointer data, gpointer user_data)
+static void __free_func(void *data, unsigned long long id, void *user_data)
 {
 	struct usmbd_tree_conn *tree_conn;
 
@@ -28,9 +27,9 @@ static void __free_func(gpointer data, g
 
 static void kill_usmbd_session(struct usmbd_session *sess)
 {
-	g_list_foreach(sess->tree_conns, __free_func, NULL);
-	g_list_free(sess->tree_conns);
-	g_rw_lock_clear(&sess->update_lock);
+	list_foreach(&sess->tree_conns, __free_func, NULL);
+	list_clear(&sess->tree_conns);
+	pthread_rwlock_destroy(&sess->update_lock);
 	free(sess);
 }
 
@@ -43,31 +42,31 @@ static struct usmbd_session *new_usmbd_s
 	if (!sess)
 		return NULL;
 
-	g_rw_lock_init(&sess->update_lock);
+	pthread_rwlock_init(&sess->update_lock, NULL);
 	sess->ref_counter = 1;
 	sess->id = id;
 	sess->user = user;
 	return sess;
 }
 
-static void free_hash_entry(gpointer k, gpointer s, gpointer user_data)
+static void free_hash_entry(void *s, unsigned long long id, void *user_data)
 {
 	kill_usmbd_session(s);
 }
 
 static void sm_clear_sessions(void)
 {
-	g_hash_table_foreach(sessions_table, free_hash_entry, NULL);
+	list_foreach(&sessions_table, free_hash_entry, NULL);
 }
 
 static int __sm_remove_session(struct usmbd_session *sess)
 {
 	int ret = -EINVAL;
 
-	g_rw_lock_writer_lock(&sessions_table_lock);
-	if (g_hash_table_remove(sessions_table, &sess->id))
+	pthread_rwlock_wrlock(&sessions_table_lock);
+	if (list_remove(&sessions_table, sess->id))
 		ret = 0;
-	g_rw_lock_writer_unlock(&sessions_table_lock);
+	pthread_rwlock_unlock(&sessions_table_lock);
 
 	if (!ret)
 		kill_usmbd_session(sess);
@@ -78,14 +77,14 @@ static struct usmbd_session *__get_sessi
 {
 	struct usmbd_session *ret = NULL;
 
-	g_rw_lock_writer_lock(&sess->update_lock);
+	pthread_rwlock_wrlock(&sess->update_lock);
 	if (sess->ref_counter != 0) {
 		sess->ref_counter++;
 		ret = sess;
 	} else {
 		ret = NULL;
 	}
-	g_rw_lock_writer_unlock(&sess->update_lock);
+	pthread_rwlock_unlock(&sess->update_lock);
 	return ret;
 }
 
@@ -93,10 +92,10 @@ static void __put_session(struct usmbd_s
 {
 	int drop = 0;
 
-	g_rw_lock_writer_lock(&sess->update_lock);
+	pthread_rwlock_wrlock(&sess->update_lock);
 	sess->ref_counter--;
 	drop = !sess->ref_counter;
-	g_rw_lock_writer_unlock(&sess->update_lock);
+	pthread_rwlock_unlock(&sess->update_lock);
 
 	if (drop)
 		__sm_remove_session(sess);
@@ -104,32 +103,21 @@ static void __put_session(struct usmbd_s
 
 static struct usmbd_session *__sm_lookup_session(unsigned long long id)
 {
-	return g_hash_table_lookup(sessions_table, &id);
+	return list_get(&sessions_table, id);
 }
 
 static struct usmbd_session *sm_lookup_session(unsigned long long id)
 {
 	struct usmbd_session *sess;
 
-	g_rw_lock_reader_lock(&sessions_table_lock);
+	pthread_rwlock_rdlock(&sessions_table_lock);
 	sess = __sm_lookup_session(id);
 	if (sess)
 		sess = __get_session(sess);
-	g_rw_lock_reader_unlock(&sessions_table_lock);
+	pthread_rwlock_unlock(&sessions_table_lock);
 	return sess;
 }
 
-static int sm_insert_session(struct usmbd_session *sess)
-{
-	int ret;
-
-	g_rw_lock_writer_lock(&sessions_table_lock);
-	ret = g_hash_table_insert(sessions_table, &(sess->id), sess);
-	g_rw_lock_writer_unlock(&sessions_table_lock);
-
-	return ret;
-}
-
 int sm_handle_tree_connect(unsigned long long id,
 			   struct usmbd_user *user,
 			   struct usmbd_tree_conn *tree_conn)
@@ -143,7 +131,7 @@ retry:
 		if (!sess)
 			return -EINVAL;
 
-		g_rw_lock_writer_lock(&sessions_table_lock);
+		pthread_rwlock_wrlock(&sessions_table_lock);
 		lookup = __sm_lookup_session(id);
 		if (lookup)
 			lookup = __get_session(lookup);
@@ -151,19 +139,19 @@ retry:
 			kill_usmbd_session(sess);
 			sess = lookup;
 		}
-		if (!g_hash_table_insert(sessions_table, &(sess->id), sess)) {
+		if (!list_add(&sessions_table, sess, sess->id)) {
 			kill_usmbd_session(sess);
 			sess = NULL;
 		}
-		g_rw_lock_writer_unlock(&sessions_table_lock);
+		pthread_rwlock_unlock(&sessions_table_lock);
 
 		if (!sess)
 			goto retry;
 	}
 
-	g_rw_lock_writer_lock(&sess->update_lock);
-	sess->tree_conns = g_list_insert(sess->tree_conns, tree_conn, -1);
-	g_rw_lock_writer_unlock(&sess->update_lock);
+	pthread_rwlock_wrlock(&sess->update_lock);
+	list_add(&sess->tree_conns, tree_conn, -1);
+	pthread_rwlock_unlock(&sess->update_lock);
 	return 0;
 }
 
@@ -174,14 +162,14 @@ int sm_check_sessions_capacity(unsigned
 	if (sm_lookup_session(id))
 		return ret;
 
-	if (g_atomic_int_add(&global_conf.sessions_cap, -1) < 1) {
+	if (atomic_int_add(&global_conf.sessions_cap, -1) < 1) {
 		ret = -EINVAL;
-		g_atomic_int_inc(&global_conf.sessions_cap);
+		atomic_int_inc(&global_conf.sessions_cap);
 	}
 	return ret;
 }
 
-static gint lookup_tree_conn(gconstpointer data, gconstpointer user_data)
+static int lookup_tree_conn(const void *data, const void *user_data)
 {
 	struct usmbd_tree_conn *tree_conn = (struct usmbd_tree_conn *)data;
 	struct usmbd_tree_conn *dummy = (struct usmbd_tree_conn *)user_data;
@@ -194,29 +182,22 @@ static gint lookup_tree_conn(gconstpoint
 int sm_handle_tree_disconnect(unsigned long long sess_id,
 			      unsigned long long tree_conn_id)
 {
-	struct usmbd_tree_conn dummy;
 	struct usmbd_session *sess;
-	GList *tc_list;
+	struct usmbd_tree_conn *tree_conn;
 
 	sess = sm_lookup_session(sess_id);
 	if (!sess)
 		return 0;
 
-	g_atomic_int_inc(&global_conf.sessions_cap);
-	g_rw_lock_writer_lock(&sess->update_lock);
-	dummy.id = tree_conn_id;
-	tc_list = g_list_find_custom(sess->tree_conns,
-				     &dummy,
-				     lookup_tree_conn);
-	if (tc_list) {
-		struct usmbd_tree_conn *tree_conn;
-
-		tree_conn = (struct usmbd_tree_conn *)tc_list->data;
-		sess->tree_conns = g_list_remove(sess->tree_conns, tree_conn);
+	atomic_int_inc(&global_conf.sessions_cap);
+	pthread_rwlock_wrlock(&sess->update_lock);
+	tree_conn = list_get(&sess->tree_conns, tree_conn_id);
+	if (tree_conn) {
+		list_remove(&sess->tree_conns, tree_conn_id);
 		sess->ref_counter--;
 		tcm_tree_conn_free(tree_conn);
 	}
-	g_rw_lock_writer_unlock(&sess->update_lock);
+	pthread_rwlock_unlock(&sess->update_lock);
 
 	__put_session(sess);
 	return 0;
@@ -226,16 +207,16 @@ void sm_destroy(void)
 {
 	if (sessions_table) {
 		sm_clear_sessions();
-		g_hash_table_destroy(sessions_table);
+		list_clear(&sessions_table);
 	}
-	g_rw_lock_clear(&sessions_table_lock);
+	pthread_rwlock_destroy(&sessions_table_lock);
 }
 
 int sm_init(void)
 {
-	sessions_table = g_hash_table_new(g_int64_hash, g_int64_equal);
+	list_init(&sessions_table);
 	if (!sessions_table)
 		return -ENOMEM;
-	g_rw_lock_init(&sessions_table_lock);
+	pthread_rwlock_init(&sessions_table_lock, NULL);
 	return 0;
 }
diff -urpN ksmbd-tools-3.1.0/lib/management/share.c ksmbd-tools-3.1.0.new/lib/management/share.c
--- ksmbd-tools-3.1.0/lib/management/share.c	2020-01-22 18:12:55.000000000 +0400
+++ ksmbd-tools-3.1.0.new/lib/management/share.c	2020-01-26 13:58:13.872726058 +0400
@@ -7,7 +7,6 @@
 
 #include <stdlib.h>
 #include <string.h>
-#include <glib.h>
 #include <sys/types.h>
 #include <pwd.h>
 #include <grp.h>
@@ -25,39 +24,39 @@
  * Add new entries ONLY to the bottom.
  */
 char *USMBD_SHARE_CONF[USMBD_SHARE_CONF_MAX] = {
-	"comment",				/* 0 */
+	"comment",		/* 0 */
 	"path",
 	"guest ok",
 	"guest account",
 	"read only",
-	"browseable",				/* 5 */
+	"browseable",		/* 5 */
 	"write ok",
 	"writeable",
 	"store dos attributes",
 	"oplocks",
-	"create mask",				/* 10 */
+	"create mask",		/* 10 */
 	"directory mask",
 	"force create mode",
 	"force directory mode",
 	"force group",
-	"force user",				/* 15 */
+	"force user",		/* 15 */
 	"hide dot files",
 	"valid users",
 	"invalid users",
 	"read list",
-	"write list",				/* 20 */
+	"write list",		/* 20 */
 	"admin users",
 	"hosts allow",
 	"hosts deny",
 	"max connections",
-	"veto files",				/* 25 */
+	"veto files",		/* 25 */
 	"inherit smack",
 	"inherit owner",
 	"streams",
 };
 
-static GHashTable	*shares_table;
-static GRWLock		shares_table_lock;
+static struct LIST *shares_table;
+static pthread_rwlock_t shares_table_lock;
 
 int shm_share_config(char *k, enum USMBD_SHARE_CONF c)
 {
@@ -67,30 +66,32 @@ int shm_share_config(char *k, enum USMBD
 	return !cp_key_cmp(k, USMBD_SHARE_CONF[c]);
 }
 
-static void list_hosts_callback(gpointer k, gpointer v, gpointer user_data)
+static void list_hosts_callback(void *item, unsigned long long id,
+				void *user_data)
 {
-	free(k);
-	free(v);
+	free(item);
+	free(list_fromkey(id));
 }
 
-static void free_hosts_map(GHashTable *map)
+static void free_hosts_map(struct LIST *map)
 {
 	if (map) {
-		g_hash_table_foreach(map, list_hosts_callback, NULL);
-		g_hash_table_destroy(map);
+		list_foreach(&map, list_hosts_callback, NULL);
+		list_clear(&map);
 	}
 }
 
-static void list_user_callback(gpointer k, gpointer u, gpointer user_data)
+static void list_user_callback(void *item, unsigned long long id,
+			       void *user_data)
 {
-	put_usmbd_user((struct usmbd_user *)u);
+	put_usmbd_user((struct usmbd_user *)item);
 }
 
-static void free_user_map(GHashTable *map)
+static void free_user_map(struct LIST *map)
 {
 	if (map) {
-		g_hash_table_foreach(map, list_user_callback, NULL);
-		g_hash_table_destroy(map);
+		list_foreach(&map, list_user_callback, NULL);
+		list_clear(&map);
 	}
 }
 
@@ -106,14 +107,14 @@ static void kill_usmbd_share(struct usmb
 	free_hosts_map(share->hosts_allow_map);
 	free_hosts_map(share->hosts_deny_map);
 
-	g_rw_lock_clear(&share->maps_lock);
+	pthread_rwlock_destroy(&share->maps_lock);
 
 	free(share->name);
 	free(share->path);
 	free(share->comment);
 	free(share->veto_list);
 	free(share->guest_account);
-	g_rw_lock_clear(&share->update_lock);
+	pthread_rwlock_destroy(&share->update_lock);
 	free(share);
 }
 
@@ -121,10 +122,10 @@ static int __shm_remove_share(struct usm
 {
 	int ret = -EINVAL;
 
-	g_rw_lock_writer_lock(&shares_table_lock);
-	if (g_hash_table_remove(shares_table, share->name))
+	pthread_rwlock_wrlock(&shares_table_lock);
+	if (list_remove(&shares_table, list_tokey(share->name)))
 		ret = 0;
-	g_rw_lock_writer_unlock(&shares_table_lock);
+	pthread_rwlock_unlock(&shares_table_lock);
 
 	if (!ret)
 		kill_usmbd_share(share);
@@ -133,12 +134,12 @@ static int __shm_remove_share(struct usm
 
 struct usmbd_share *get_usmbd_share(struct usmbd_share *share)
 {
-	g_rw_lock_writer_lock(&share->update_lock);
+	pthread_rwlock_wrlock(&share->update_lock);
 	if (share->ref_count != 0)
 		share->ref_count++;
 	else
 		share = NULL;
-	g_rw_lock_writer_unlock(&share->update_lock);
+	pthread_rwlock_unlock(&share->update_lock);
 
 	return share;
 }
@@ -150,10 +151,10 @@ void put_usmbd_share(struct usmbd_share
 	if (!share)
 		return;
 
-	g_rw_lock_writer_lock(&share->update_lock);
+	pthread_rwlock_wrlock(&share->update_lock);
 	share->ref_count--;
 	drop = !share->ref_count;
-	g_rw_lock_writer_unlock(&share->update_lock);
+	pthread_rwlock_unlock(&share->update_lock);
 
 	if (!drop)
 		return;
@@ -180,61 +181,61 @@ static struct usmbd_share *new_usmbd_sha
 
 	share->hosts_allow_map = NULL;
 	share->hosts_deny_map = NULL;
-	g_rw_lock_init(&share->maps_lock);
-	g_rw_lock_init(&share->update_lock);
+	pthread_rwlock_init(&share->maps_lock, NULL);
+	pthread_rwlock_init(&share->update_lock, NULL);
 
 	return share;
 }
 
-static void free_hash_entry(gpointer k, gpointer s, gpointer user_data)
+static void free_hash_entry(void *item, unsigned long long id, void *user_data)
 {
-	kill_usmbd_share(s);
+	kill_usmbd_share(item);
 }
 
 static void shm_clear_shares(void)
 {
-	g_hash_table_foreach(shares_table, free_hash_entry, NULL);
+	list_foreach(&shares_table, free_hash_entry, NULL);
 }
 
 void shm_destroy(void)
 {
 	if (shares_table) {
 		shm_clear_shares();
-		g_hash_table_destroy(shares_table);
+		list_clear(&shares_table);
 	}
-	g_rw_lock_clear(&shares_table_lock);
+	pthread_rwlock_destroy(&shares_table_lock);
 }
 
 int shm_init(void)
 {
-	shares_table = g_hash_table_new(g_str_hash, g_str_equal);
+	list_init(&shares_table);
 	if (!shares_table)
 		return -ENOMEM;
-	g_rw_lock_init(&shares_table_lock);
+	pthread_rwlock_init(&shares_table_lock, NULL);
 	return 0;
 }
 
 static struct usmbd_share *__shm_lookup_share(char *name)
 {
-	return g_hash_table_lookup(shares_table, name);
+	return (struct usmbd_share *)list_get(&shares_table, list_tokey(name));
 }
 
 struct usmbd_share *shm_lookup_share(char *name)
 {
 	struct usmbd_share *share, *ret;
 
-	g_rw_lock_reader_lock(&shares_table_lock);
+	pthread_rwlock_rdlock(&shares_table_lock);
 	share = __shm_lookup_share(name);
 	if (share) {
 		ret = get_usmbd_share(share);
 		if (!ret)
 			share = NULL;
 	}
-	g_rw_lock_reader_unlock(&shares_table_lock);
+	pthread_rwlock_unlock(&shares_table_lock);
 	return share;
 }
 
-static GHashTable *parse_list(GHashTable *map, char **list)
+static struct LIST *parse_list(struct LIST *map, char **list)
 {
 	int i;
 
@@ -242,11 +243,11 @@ static GHashTable *parse_list(GHashTable
 		return map;
 
 	if (!map)
-		map = g_hash_table_new(g_str_hash, g_str_equal);
+		list_init(&map);
 	if (!map)
 		return map;
 
-	for (i = 0;  list[i] != NULL; i++) {
+	for (i = 0; list[i] != NULL; i++) {
 		struct usmbd_user *user;
 		char *p = list[i];
 
@@ -260,12 +261,12 @@ static GHashTable *parse_list(GHashTable
 			continue;
 		}
 
-		if (g_hash_table_lookup(map, user->name)) {
+		if (list_get(&map, list_tokey(user->name))) {
 			pr_debug("User already exists in a map: %s\n", p);
 			continue;
 		}
 
-		g_hash_table_insert(map, user->name, user);
+		list_add_str(&map, user, user->name);
 	}
 
 	cp_group_kv_list_free(list);
@@ -311,11 +312,11 @@ static void force_user(struct usmbd_shar
 	}
 }
 
-static void process_group_kv(gpointer _k, gpointer _v, gpointer user_data)
+static void process_group_kv(void *_v, unsigned long long _k, void *user_data)
 {
 	struct usmbd_share *share = user_data;
-	char *k = _k;
-	char *v = _v;
+	char *k = (char *)list_fromkey(_k);
+	char *v = (char *)_v;
 
 	if (shm_share_config(k, USMBD_SHARE_CONF_COMMENT)) {
 		share->comment = cp_get_group_kv_string(v);
@@ -341,7 +342,7 @@ static void process_group_kv(gpointer _k
 		struct usmbd_user *user;
 
 		if (usm_add_new_user(cp_get_group_kv_string(_v),
-				     g_strdup("NULL"))) {
+				     strdup("NULL"))) {
 			pr_err("Unable to add guest account\n");
 			set_share_flag(share, USMBD_SHARE_FLAG_INVALID);
 			return;
@@ -378,7 +379,7 @@ static void process_group_kv(gpointer _k
 	}
 
 	if (shm_share_config(k, USMBD_SHARE_CONF_WRITE_OK) ||
-			shm_share_config(k, USMBD_SHARE_CONF_WRITEABLE)) {
+	    shm_share_config(k, USMBD_SHARE_CONF_WRITEABLE)) {
 		if (cp_get_group_kv_bool(v))
 			set_share_flag(share, USMBD_SHARE_FLAG_WRITEABLE);
 		else
@@ -391,7 +392,7 @@ static void process_group_kv(gpointer _k
 			set_share_flag(share, USMBD_SHARE_FLAG_STORE_DOS_ATTRS);
 		else
 			clear_share_flag(share,
-					USMBD_SHARE_FLAG_STORE_DOS_ATTRS);
+					 USMBD_SHARE_FLAG_STORE_DOS_ATTRS);
 		return;
 	}
 
@@ -438,13 +439,13 @@ static void process_group_kv(gpointer _k
 			set_share_flag(share, USMBD_SHARE_FLAG_HIDE_DOT_FILES);
 		else
 			clear_share_flag(share,
-				USMBD_SHARE_FLAG_HIDE_DOT_FILES);
+					 USMBD_SHARE_FLAG_HIDE_DOT_FILES);
 	}
 
 	if (shm_share_config(k, USMBD_SHARE_CONF_VALID_USERS)) {
 		share->maps[USMBD_SHARE_VALID_USERS_MAP] =
-			parse_list(share->maps[USMBD_SHARE_VALID_USERS_MAP],
-				cp_get_group_kv_list(v));
+		    parse_list(share->maps[USMBD_SHARE_VALID_USERS_MAP],
+			       cp_get_group_kv_list(v));
 		if (share->maps[USMBD_SHARE_VALID_USERS_MAP] == NULL)
 			set_share_flag(share, USMBD_SHARE_FLAG_INVALID);
 		return;
@@ -452,8 +453,8 @@ static void process_group_kv(gpointer _k
 
 	if (shm_share_config(k, USMBD_SHARE_CONF_INVALID_USERS)) {
 		share->maps[USMBD_SHARE_INVALID_USERS_MAP] =
-			parse_list(share->maps[USMBD_SHARE_INVALID_USERS_MAP],
-				cp_get_group_kv_list(v));
+		    parse_list(share->maps[USMBD_SHARE_INVALID_USERS_MAP],
+			       cp_get_group_kv_list(v));
 		if (share->maps[USMBD_SHARE_INVALID_USERS_MAP] == NULL)
 			set_share_flag(share, USMBD_SHARE_FLAG_INVALID);
 		return;
@@ -461,8 +462,8 @@ static void process_group_kv(gpointer _k
 
 	if (shm_share_config(k, USMBD_SHARE_CONF_READ_LIST)) {
 		share->maps[USMBD_SHARE_READ_LIST_MAP] =
-			parse_list(share->maps[USMBD_SHARE_READ_LIST_MAP],
-				   cp_get_group_kv_list(v));
+		    parse_list(share->maps[USMBD_SHARE_READ_LIST_MAP],
+			       cp_get_group_kv_list(v));
 		if (share->maps[USMBD_SHARE_READ_LIST_MAP] == NULL)
 			set_share_flag(share, USMBD_SHARE_FLAG_INVALID);
 		return;
@@ -470,8 +471,8 @@ static void process_group_kv(gpointer _k
 
 	if (shm_share_config(k, USMBD_SHARE_CONF_WRITE_LIST)) {
 		share->maps[USMBD_SHARE_WRITE_LIST_MAP] =
-			parse_list(share->maps[USMBD_SHARE_WRITE_LIST_MAP],
-				   cp_get_group_kv_list(v));
+		    parse_list(share->maps[USMBD_SHARE_WRITE_LIST_MAP],
+			       cp_get_group_kv_list(v));
 		if (share->maps[USMBD_SHARE_WRITE_LIST_MAP] == NULL)
 			set_share_flag(share, USMBD_SHARE_FLAG_INVALID);
 		return;
@@ -479,8 +480,8 @@ static void process_group_kv(gpointer _k
 
 	if (shm_share_config(k, USMBD_SHARE_CONF_ADMIN_USERS)) {
 		share->maps[USMBD_SHARE_ADMIN_USERS_MAP] =
-			parse_list(share->maps[USMBD_SHARE_ADMIN_USERS_MAP],
-				   cp_get_group_kv_list(v));
+		    parse_list(share->maps[USMBD_SHARE_ADMIN_USERS_MAP],
+			       cp_get_group_kv_list(v));
 		if (share->maps[USMBD_SHARE_ADMIN_USERS_MAP] == NULL)
 			set_share_flag(share, USMBD_SHARE_FLAG_INVALID);
 		return;
@@ -522,28 +523,28 @@ static void process_group_kv(gpointer _k
 		if (cp_get_group_kv_bool(v))
 			set_share_flag(share, USMBD_SHARE_FLAG_INHERIT_SMACK);
 		else
-			clear_share_flag(share,	USMBD_SHARE_FLAG_INHERIT_SMACK);
+			clear_share_flag(share, USMBD_SHARE_FLAG_INHERIT_SMACK);
 	}
 
 	if (shm_share_config(k, USMBD_SHARE_CONF_INHERIT_OWNER)) {
 		if (cp_get_group_kv_bool(v))
 			set_share_flag(share, USMBD_SHARE_FLAG_INHERIT_OWNER);
 		else
-			clear_share_flag(share,	USMBD_SHARE_FLAG_INHERIT_OWNER);
+			clear_share_flag(share, USMBD_SHARE_FLAG_INHERIT_OWNER);
 	}
 
 	if (shm_share_config(k, USMBD_SHARE_CONF_STREAMS)) {
 		if (cp_get_group_kv_bool(v))
 			set_share_flag(share, USMBD_SHARE_FLAG_STREAMS);
 		else
-			clear_share_flag(share,	USMBD_SHARE_FLAG_STREAMS);
+			clear_share_flag(share, USMBD_SHARE_FLAG_STREAMS);
 	}
 }
 
 static void init_share_from_group(struct usmbd_share *share,
-				 struct smbconf_group *group)
+				  struct smbconf_group *group)
 {
-	share->name = g_strdup(group->name);
+	share->name = strdup(group->name);
 	share->create_mask = USMBD_SHARE_DEFAULT_CREATE_MASK;
 	share->directory_mask = USMBD_SHARE_DEFAULT_DIRECTORY_MASK;
 	share->force_create_mode = 0;
@@ -560,7 +561,7 @@ static void init_share_from_group(struct
 	if (!cp_key_cmp(share->name, "IPC$"))
 		set_share_flag(share, USMBD_SHARE_FLAG_PIPE);
 
-	g_hash_table_foreach(group->kv, process_group_kv, share);
+	list_foreach(&(group->kv), process_group_kv, share);
 }
 
 int shm_add_new_share(struct smbconf_group *group)
@@ -578,25 +579,24 @@ int shm_add_new_share(struct smbconf_gro
 		return 0;
 	}
 
-	g_rw_lock_writer_lock(&shares_table_lock);
+	pthread_rwlock_wrlock(&shares_table_lock);
 	if (__shm_lookup_share(share->name)) {
-		g_rw_lock_writer_unlock(&shares_table_lock);
+		pthread_rwlock_unlock(&shares_table_lock);
 		pr_info("share exists %s\n", share->name);
 		kill_usmbd_share(share);
 		return 0;
 	}
 
-	if (!g_hash_table_insert(shares_table, share->name, share)) {
+	if (!list_add_str(&shares_table, share, share->name)) {
 		kill_usmbd_share(share);
 		ret = -EINVAL;
 	}
-	g_rw_lock_writer_unlock(&shares_table_lock);
+	pthread_rwlock_unlock(&shares_table_lock);
 	return ret;
 }
 
 int shm_lookup_users_map(struct usmbd_share *share,
-			  enum share_users map,
-			  char *name)
+			 enum share_users map, char *name)
 {
 	int ret = -ENOENT;
 
@@ -608,10 +608,10 @@ int shm_lookup_users_map(struct usmbd_sh
 	if (!share->maps[map])
 		return -EINVAL;
 
-	g_rw_lock_reader_lock(&share->maps_lock);
-	if (g_hash_table_lookup(share->maps[map], name))
+	pthread_rwlock_rdlock(&share->maps_lock);
+	if (list_get(&share->maps[map], list_tokey(name)))
 		ret = 0;
-	g_rw_lock_reader_unlock(&share->maps_lock);
+	pthread_rwlock_unlock(&share->maps_lock);
 
 	return ret;
 }
@@ -621,10 +621,9 @@ int shm_lookup_users_map(struct usmbd_sh
  * Do a real hosts lookup. IP masks, etc.
  */
 int shm_lookup_hosts_map(struct usmbd_share *share,
-			  enum share_hosts map,
-			  char *host)
+			 enum share_hosts map, char *host)
 {
-	GHashTable *lookup_map;
+	struct LIST *lookup_map;
 	int ret = -ENOENT;
 
 	if (map >= USMBD_SHARE_HOSTS_MAX) {
@@ -640,10 +639,10 @@ int shm_lookup_hosts_map(struct usmbd_sh
 	if (!lookup_map)
 		return -EINVAL;
 
-	g_rw_lock_reader_lock(&share->maps_lock);
-	if (g_hash_table_lookup(lookup_map, host))
+	pthread_rwlock_rdlock(&share->maps_lock);
+	if (list_get(&lookup_map, list_tokey(host)))
 		ret = 0;
-	g_rw_lock_reader_unlock(&share->maps_lock);
+	pthread_rwlock_unlock(&share->maps_lock);
 
 	return ret;
 }
@@ -652,13 +651,13 @@ int shm_open_connection(struct usmbd_sha
 {
 	int ret = 0;
 
-	g_rw_lock_writer_lock(&share->update_lock);
+	pthread_rwlock_wrlock(&share->update_lock);
 	share->num_connections++;
 	if (share->max_connections) {
 		if (share->num_connections >= share->max_connections)
 			ret = -EINVAL;
 	}
-	g_rw_lock_writer_unlock(&share->update_lock);
+	pthread_rwlock_unlock(&share->update_lock);
 	return ret;
 }
 
@@ -667,17 +666,17 @@ int shm_close_connection(struct usmbd_sh
 	if (!share)
 		return 0;
 
-	g_rw_lock_writer_lock(&share->update_lock);
+	pthread_rwlock_wrlock(&share->update_lock);
 	share->num_connections--;
-	g_rw_lock_writer_unlock(&share->update_lock);
+	pthread_rwlock_unlock(&share->update_lock);
 	return 0;
 }
 
-void for_each_usmbd_share(walk_shares cb, gpointer user_data)
+void foreach_usmbd_share(walk_shares cb, void *user_data)
 {
-	g_rw_lock_reader_lock(&shares_table_lock);
-	g_hash_table_foreach(shares_table, cb, user_data);
-	g_rw_lock_reader_unlock(&shares_table_lock);
+	pthread_rwlock_rdlock(&shares_table_lock);
+	list_foreach(&shares_table, cb, user_data);
+	pthread_rwlock_unlock(&shares_table_lock);
 }
 
 int shm_share_config_payload_size(struct usmbd_share *share)
@@ -721,16 +720,12 @@ int shm_handle_share_config_request(stru
 
 	config_payload = USMBD_SHARE_CONFIG_VETO_LIST(resp);
 	if (resp->veto_list_sz) {
-		memcpy(config_payload,
-		       share->veto_list,
-		       resp->veto_list_sz);
+		memcpy(config_payload, share->veto_list, resp->veto_list_sz);
 		config_payload += resp->veto_list_sz + 1;
 	}
 	if (global_conf.root_dir)
 		sprintf(config_payload,
-			"%s%s",
-			global_conf.root_dir,
-			share->path);
+			"%s%s", global_conf.root_dir, share->path);
 	else
 		sprintf(config_payload, "%s", share->path);
 	return 0;
diff -urpN ksmbd-tools-3.1.0/lib/management/tree_conn.c ksmbd-tools-3.1.0.new/lib/management/tree_conn.c
--- ksmbd-tools-3.1.0/lib/management/tree_conn.c	2020-01-22 18:12:55.000000000 +0400
+++ ksmbd-tools-3.1.0.new/lib/management/tree_conn.c	2020-01-26 15:34:56.345726417 +0400
@@ -7,7 +7,6 @@
 
 #include <stdlib.h>
 #include <string.h>
-#include <glib.h>
 #include <linux/usmbd_server.h>
 
 #include <management/tree_conn.h>
diff -urpN ksmbd-tools-3.1.0/lib/management/user.c ksmbd-tools-3.1.0.new/lib/management/user.c
--- ksmbd-tools-3.1.0/lib/management/user.c	2020-01-22 18:12:55.000000000 +0400
+++ ksmbd-tools-3.1.0.new/lib/management/user.c	2020-01-26 13:58:13.872726058 +0400
@@ -7,14 +7,14 @@
 
 #include <stdlib.h>
 #include <string.h>
-#include <glib.h>
+#include <pthread.h>
 #include <linux/usmbd_server.h>
 
 #include <management/user.h>
 #include <usmbdtools.h>
 
-static GHashTable	*users_table;
-static GRWLock		users_table_lock;
+static struct LIST *users_table;
+static pthread_rwlock_t users_table_lock;
 
 static void kill_usmbd_user(struct usmbd_user *user)
 {
@@ -23,7 +23,7 @@ static void kill_usmbd_user(struct usmbd
 	free(user->name);
 	free(user->pass_b64);
 	free(user->pass);
-	g_rw_lock_clear(&user->update_lock);
+	pthread_rwlock_destroy(&user->update_lock);
 	free(user);
 }
 
@@ -31,10 +31,10 @@ static int __usm_remove_user(struct usmb
 {
 	int ret = -EINVAL;
 
-	g_rw_lock_writer_lock(&users_table_lock);
-	if (g_hash_table_remove(users_table, user->name))
+	pthread_rwlock_wrlock(&users_table_lock);
+	if (list_remove(&users_table, list_tokey(user->name)))
 		ret = 0;
-	g_rw_lock_writer_unlock(&users_table_lock);
+	pthread_rwlock_unlock(&users_table_lock);
 
 	if (!ret)
 		kill_usmbd_user(user);
@@ -43,12 +43,12 @@ static int __usm_remove_user(struct usmb
 
 struct usmbd_user *get_usmbd_user(struct usmbd_user *user)
 {
-	g_rw_lock_writer_lock(&user->update_lock);
+	pthread_rwlock_wrlock(&user->update_lock);
 	if (user->ref_count != 0)
 		user->ref_count++;
 	else
 		user = NULL;
-	g_rw_lock_writer_unlock(&user->update_lock);
+	pthread_rwlock_unlock(&user->update_lock);
 	return user;
 }
 
@@ -59,10 +59,10 @@ void put_usmbd_user(struct usmbd_user *u
 	if (!user)
 		return;
 
-	g_rw_lock_writer_lock(&user->update_lock);
+	pthread_rwlock_wrlock(&user->update_lock);
 	user->ref_count--;
 	drop = !user->ref_count;
-	g_rw_lock_writer_unlock(&user->update_lock);
+	pthread_rwlock_unlock(&user->update_lock);
 
 	if (!drop)
 		return;
@@ -80,7 +80,7 @@ static struct usmbd_user *new_usmbd_user
 	if (!user)
 		return NULL;
 
-	g_rw_lock_clear(&user->update_lock);
+	pthread_rwlock_destroy(&user->update_lock);
 	user->name = name;
 	user->pass_b64 = pwd;
 	user->ref_count = 1;
@@ -97,37 +97,37 @@ static struct usmbd_user *new_usmbd_user
 	return user;
 }
 
-static void free_hash_entry(gpointer k, gpointer u, gpointer user_data)
+static void free_hash_entry(void *u, unsigned long long id, void *user_data)
 {
 	kill_usmbd_user(u);
 }
 
 static void usm_clear_users(void)
 {
-	g_hash_table_foreach(users_table, free_hash_entry, NULL);
+	list_foreach(&users_table, free_hash_entry, NULL);
 }
 
 void usm_destroy(void)
 {
 	if (users_table) {
 		usm_clear_users();
-		g_hash_table_destroy(users_table);
+		list_clear(&users_table);
 	}
-	g_rw_lock_clear(&users_table_lock);
+	pthread_rwlock_destroy(&users_table_lock);
 }
 
 int usm_init(void)
 {
-	users_table = g_hash_table_new(g_str_hash, g_str_equal);
+	list_init(&users_table);
 	if (!users_table)
 		return -ENOMEM;
-	g_rw_lock_init(&users_table_lock);
+	pthread_rwlock_init(&users_table_lock, NULL);
 	return 0;
 }
 
 static struct usmbd_user *__usm_lookup_user(char *name)
 {
-	return g_hash_table_lookup(users_table, name);
+	return list_get(&users_table, list_tokey(name));
 }
 
 struct usmbd_user *usm_lookup_user(char *name)
@@ -137,14 +137,14 @@ struct usmbd_user *usm_lookup_user(char
 	if (!name)
 		return NULL;
 
-	g_rw_lock_reader_lock(&users_table_lock);
+	pthread_rwlock_rdlock(&users_table_lock);
 	user = __usm_lookup_user(name);
 	if (user) {
 		ret = get_usmbd_user(user);
 		if (!ret)
 			user = NULL;
 	}
-	g_rw_lock_reader_unlock(&users_table_lock);
+	pthread_rwlock_unlock(&users_table_lock);
 	return user;
 }
 
@@ -159,19 +159,18 @@ int usm_add_new_user(char *name, char *p
 		return -ENOMEM;
 	}
 
-	g_rw_lock_writer_lock(&users_table_lock);
+	pthread_rwlock_wrlock(&users_table_lock);
 	if (__usm_lookup_user(name)) {
-		g_rw_lock_writer_unlock(&users_table_lock);
+		pthread_rwlock_unlock(&users_table_lock);
 		pr_info("User already exists %s\n", name);
 		kill_usmbd_user(user);
 		return 0;
 	}
-
-	if (!g_hash_table_insert(users_table, user->name, user)) {
+	if (!list_add_str(&users_table, user, user->name)) {
 		kill_usmbd_user(user);
 		ret = -EINVAL;
 	}
-	g_rw_lock_writer_unlock(&users_table_lock);
+	pthread_rwlock_unlock(&users_table_lock);
 	return ret;
 }
 
@@ -189,8 +188,8 @@ int usm_add_update_user_from_pwdentry(ch
 	}
 
 	*pos = 0x00;
-	name = g_strdup(data);
-	pwd = g_strdup(pos + 1);
+	name = strdup(data);
+	pwd = strdup(pos + 1);
 
 	if (!name || !pwd) {
 		free(name);
@@ -210,17 +209,17 @@ int usm_add_update_user_from_pwdentry(ch
 	return usm_add_new_user(name, pwd);
 }
 
-void for_each_usmbd_user(walk_users cb, gpointer user_data)
+void foreach_usmbd_user(walk_users cb, void *user_data)
 {
-	g_rw_lock_reader_lock(&users_table_lock);
-	g_hash_table_foreach(users_table, cb, user_data);
-	g_rw_lock_reader_unlock(&users_table_lock);
+	pthread_rwlock_rdlock(&users_table_lock);
+	list_foreach(&users_table, cb, user_data);
+	pthread_rwlock_unlock(&users_table_lock);
 }
 
 int usm_update_user_password(struct usmbd_user *user, char *pswd)
 {
 	size_t pass_sz;
-	char *pass_b64 = g_strdup(pswd);
+	char *pass_b64 = strdup(pswd);
 	char *pass = base64_decode(pass_b64, &pass_sz);
 
 	if (!pass_b64 || !pass) {
@@ -231,13 +230,13 @@ int usm_update_user_password(struct usmb
 	}
 
 	pr_debug("Update user password: %s\n", user->name);
-	g_rw_lock_writer_lock(&user->update_lock);
+	pthread_rwlock_wrlock(&user->update_lock);
 	free(user->pass_b64);
 	free(user->pass);
 	user->pass_b64 = pass_b64;
 	user->pass = pass;
 	user->pass_sz = (int)pass_sz;
-	g_rw_lock_writer_unlock(&user->update_lock);
+	pthread_rwlock_unlock(&user->update_lock);
 
 	return 0;
 }
@@ -251,12 +250,12 @@ static int usm_copy_user_passhash(struct
 	if (test_user_flag(user, USMBD_USER_FLAG_GUEST_ACCOUNT))
 		return 0;
 
-	g_rw_lock_reader_lock(&user->update_lock);
+	pthread_rwlock_rdlock(&user->update_lock);
 	if (sz >= user->pass_sz) {
 		memcpy(pass, user->pass, user->pass_sz);
 		ret = user->pass_sz;
 	}
-	g_rw_lock_reader_unlock(&user->update_lock);
+	pthread_rwlock_unlock(&user->update_lock);
 
 	return ret;
 }
